﻿using System;

namespace HtmlEditor
{
    public partial class frmMain
        : System.Windows.Forms.Form
    {
        //________________________________________________________________________

        public frmMain()
        {
            this.InitializeComponent();
            //--------------
            this.btn_Bold.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontBold;
            this.btn_Center.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.AlignCenter;
            this.btn_Italic.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontItalic;
            this.btn_Left.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.AlignLeft;
            this.btn_Right.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.AlignRight;
            this.btn_StrikeThrough.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontStrikeThrough;
            this.btn_Underline.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontUnderline;
            this.btn_Cut.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.Cut;
            this.btn_Copy.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.Copy;
            this.btn_Paste.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.Paste;
            this.btn_Indent.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.Indent;
            this.btn_Outdent.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.Outdent;
            this.btn_Subscript.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontSubscript;
            this.btn_Superscript.Tag = GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontSuperscript;
        }
        //________________________________________________________________________

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);
            this.WB.BodyHtml = "Mahdi";
        }
        //________________________________________________________________________

        #region " Commands "

        private void btn_Global_Click(object sender, EventArgs e)
        {
            var btn = sender as System.Windows.Forms.ToolStripItem;
            if (btn == null) return;

            this.WB.ExecCommand((GHDiamond.Windows.Forms.HtmlEditorBox.Command)btn.Tag);
        }
        //________________________________________________________________________

        private void btn_ForeColor_Click(object sender, EventArgs e)
        {
            var color = this.GetColorDialog();
            if (color.HasValue)
            {
                this.WB.ExecCommand(GHDiamond.Windows.Forms.HtmlEditorBox.Command.ForeColor, color);
            }
        }
        //________________________________________________________________________

        private void btn_BackColor_Click(object sender, EventArgs e)
        {
            var color = this.GetColorDialog();
            if (color.HasValue)
            {
                this.WB.ExecCommand(GHDiamond.Windows.Forms.HtmlEditorBox.Command.BackColor, color);
            }
        }
        //________________________________________________________________________

        private void btn_Font_Click(object sender, EventArgs e)
        {
            var font = this.GetFontDialog();
            if (font != null)
            {
                this.WB.ExecCommand(GHDiamond.Windows.Forms.HtmlEditorBox.Command.Font, font);
            }
        }
        //________________________________________________________________________

        private void cmbFontSize_TextChanged(object sender, EventArgs e)
        {
            int ifs;
            if (int.TryParse(this.cmbFontSize.Text, out ifs))
            {
                this.WB.ExecCommand(GHDiamond.Windows.Forms.HtmlEditorBox.Command.FontSize, ifs);
            }
        }
        //________________________________________________________________________

        #endregion

        private void btn_ShowHtml_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.MessageBox.Show(this, this.WB.BodyHtml, "BodyHtml");
            System.Windows.Forms.MessageBox.Show(this, this.WB.DocumentText, "DocumentText");
        }
        //________________________________________________________________________

        private System.Drawing.Color? GetColorDialog()
        {
            using (System.Windows.Forms.ColorDialog dialog = new System.Windows.Forms.ColorDialog())
            {
                if (dialog.ShowDialog(this) != System.Windows.Forms.DialogResult.OK) return null;
                return dialog.Color;
            }
        }
        //________________________________________________________________________

        private System.Drawing.Font GetFontDialog()
        {
            using (System.Windows.Forms.FontDialog dialog = new System.Windows.Forms.FontDialog())
            {
                if (dialog.ShowDialog(this) != System.Windows.Forms.DialogResult.OK) return null;
                return dialog.Font;
            }
        }
        //________________________________________________________________________

    }
}
